%global somajor 1
%global libname %mklibname zck %{somajor}
%global devname %mklibname zck -d

Name:           zchunk
Version:        1.3.2
Release:        %mkrel 1
Summary:        Compressed file format that allows easy deltas
Group:          Archiving/Compression
License:        BSD and MIT
URL:            https://github.com/zchunk/zchunk
Source0:        %{url}/archive/%{version}/%{name}-%{version}.tar.gz
BuildRequires:  pkgconfig(libzstd)
BuildRequires:  pkgconfig(libcurl)
BuildRequires:  pkgconfig(openssl)
BuildRequires:  meson >= 0.44.0

Provides:       bundled(buzhash-urlblock) = 0.1

%description
zchunk is a compressed file format that splits the file into independent
chunks.  This allows you to only download the differences when downloading a
new version of the file, and also makes zchunk files efficient over rsync.
zchunk files are protected with strong checksums to verify that the file you
downloaded is in fact the file you wanted.

%package -n %{libname}
Summary:  Zchunk library
Group:    System/Libraries

%description -n %{libname}
zchunk is a compressed file format that splits the file into independent
chunks.  This allows you to only download the differences when downloading a
new version of the file, and also makes zchunk files efficient over rsync.
zchunk files are protected with strong checksums to verify that the file you
downloaded is in fact the file you wanted.

This package contains the zchunk library, libzck.

%package -n %{devname}
Summary:  Headers for building against zchunk
Group:    Development/C
Provides: libzck-devel = %{version}-%{release}
Provides: libzck-devel%{?_isa} = %{version}-%{release}
Provides: zck-devel = %{version}-%{release}
Provides: zck-devel%{?_isa} = %{version}-%{release}
Provides: %{name}-devel = %{version}-%{release}
Provides: %{name}-devel%{?_isa} = %{version}-%{release}
Requires: %{libname}%{?_isa} = %{version}-%{release}

%description -n %{devname}
zchunk is a compressed file format that splits the file into independent
chunks.  This allows you to only download the differences when downloading a
new version of the file, and also makes zchunk files efficient over rsync.
zchunk files are protected with strong checksums to verify that the file you
downloaded is in fact the file you wanted.

This package contains the headers necessary for building against the zchunk
library, libzck.

%prep
%autosetup
# Remove bundled sha libraries
rm -rf src/lib/hash/sha*

%build
%meson -Dwith-openssl=enabled -Dwith-zstd=enabled
%meson_build

%install
%meson_install

# Install script for generating XML dictionaries
install -Dpm 0755 contrib/gen_xml_dictionary %{buildroot}%{_libexecdir}/zck_gen_xml_dictionary

%check
%meson_test


%files
%doc README.md contrib
%license LICENSE
%{_bindir}/zck*
%{_bindir}/unzck
%{_libexecdir}/zck_gen_xml_dictionary
%{_mandir}/man1/*.1*

%files -n %{libname}
%license LICENSE
%doc README.md
%{_libdir}/libzck.so.%{somajor}
%{_libdir}/libzck.so.%{version}

%files -n %{devname}
%doc zchunk_format.txt
%{_libdir}/libzck.so
%{_libdir}/pkgconfig/zck.pc
%{_includedir}/zck.h



%changelog
* Mon Nov 20 2023 wally <wally> 1.3.2-1.mga10
+ Revision: 2008503
- new version 1.3.2

* Tue Jun 27 2023 tmb <tmb> 1.3.1-1.mga9
+ Revision: 1963224
- 1.3.1 (security fixes, mga#31771)

* Tue Feb 21 2023 luigiwalser <luigiwalser> 1.2.4-1.mga9
+ Revision: 1944560
- 1.2.4

* Tue Sep 20 2022 luigiwalser <luigiwalser> 1.2.3-1.mga9
+ Revision: 1890781
- 1.2.3

* Fri Apr 29 2022 ns80 <ns80> 1.2.2-1.mga9
+ Revision: 1855161
- new version 1.2.2 (mga#30343)

* Thu Mar 24 2022 umeabot <umeabot> 1.2.1-2.mga9
+ Revision: 1825145
- Mageia 9 Mass Rebuild

* Fri Mar 18 2022 luigiwalser <luigiwalser> 1.2.1-1.mga9
+ Revision: 1798842
- 1.2.1

* Wed Mar 02 2022 luigiwalser <luigiwalser> 1.2.0-1.mga9
+ Revision: 1787911
- 1.2.0

* Sat Oct 02 2021 wally <wally> 1.1.16-2.mga9
+ Revision: 1747564
- rebuild for openssl 3.0.0

* Sun Aug 08 2021 luigiwalser <luigiwalser> 1.1.16-1.mga9
+ Revision: 1740129
- 1.1.16

* Tue Aug 03 2021 luigiwalser <luigiwalser> 1.1.15-1.mga9
+ Revision: 1738732
- 1.1.15

* Thu Dec 31 2020 daviddavid <daviddavid> 1.1.9-1.mga8
+ Revision: 1666723
- new version: 1.1.9
- new version: 1.1.8

* Wed Dec 02 2020 luigiwalser <luigiwalser> 1.1.7-1.mga8
+ Revision: 1651834
- 1.1.7

* Wed Feb 19 2020 umeabot <umeabot> 1.1.5-2.mga8
+ Revision: 1543443
- Mageia 8 Mass Rebuild

* Sun Jan 19 2020 ngompa <ngompa> 1.1.5-1.mga8
+ Revision: 1481567
- Update to 1.1.5

* Sun Dec 08 2019 ngompa <ngompa> 1.1.4-1.mga8
+ Revision: 1465099
- Update to 1.1.4

* Mon May 13 2019 luigiwalser <luigiwalser> 1.1.1-1.mga7
+ Revision: 1397534
- 1.1.1

* Thu Apr 18 2019 umeabot <umeabot> 1.1.0-2.mga7
+ Revision: 1392991
- Rebuild with meson 0.50.1

* Fri Mar 29 2019 luigiwalser <luigiwalser> 1.1.0-1.mga7
+ Revision: 1381099
- 1.1.0

* Mon Jan 28 2019 luigiwalser <luigiwalser> 1.0.3-1.mga7
+ Revision: 1361529
- 1.0.3

* Tue Jan 01 2019 luigiwalser <luigiwalser> 1.0.2-1.mga7
+ Revision: 1347916
- 1.0.2

* Sat Dec 22 2018 ngompa <ngompa> 1.0.0-1.mga7
+ Revision: 1344550
- Update to 1.0.0

* Sat Dec 15 2018 ngompa <ngompa> 0.9.17-1.mga7
+ Revision: 1341486
- Update to 0.9.17

* Thu Nov 08 2018 ngompa <ngompa> 0.9.14-1.mga7
+ Revision: 1328986
- Update to 0.9.14

* Sun Oct 28 2018 ngompa <ngompa> 0.9.13-1.mga7
+ Revision: 1326312
- Update to 0.9.13

* Sat Sep 29 2018 ngompa <ngompa> 0.9.11-1.mga7
+ Revision: 1310889
- Update to 0.9.11
+ umeabot <umeabot>
- Mageia 7 Mass Rebuild

* Sat Aug 11 2018 ngompa <ngompa> 0.9.7-1.mga7
+ Revision: 1251065
- Rebase to 0.9.7

* Wed Jul 18 2018 ngompa <ngompa> 0.7.6-2.mga7
+ Revision: 1244148
- Fix compatibility provides statements

* Tue Jul 17 2018 ngompa <ngompa> 0.7.6-1.mga7
+ Revision: 1243986
- Update to 0.7.6

* Thu Jul 05 2018 ngompa <ngompa> 0.7.5-5.mga7
+ Revision: 1241850
- Add compatibility Provides to devel subpackage

* Thu Jul 05 2018 ngompa <ngompa> 0.7.5-4.mga7
+ Revision: 1241845
- Adapt for Mageia
- imported package zchunk


* Wed Jul 04 2018 Jonathan Dieter <jdieter@gmail.com> - 0.7.5-3
- Fix ldconfig scriptlets to run on libs package
- Rename zchunk-libs-devel to zchunk-devel

* Tue Jul 03 2018 Jonathan Dieter <jdieter@gmail.com> - 0.7.5-1
- Split libs into separate package
- Fix license
- Provide bundled buzhash
- Fix punctuation
- Simplify source0 using url macro
- Remove bundled sha library and add dependency on OpenSSL

* Mon Jul 02 2018 Jonathan Dieter <jdieter@gmail.com> - 0.7.4-2
- Add zchunk format definition to -devel documentation

* Fri Jun 22 2018 Jonathan Dieter <jdieter@gmail.com> - 0.7.4-1
- Add --stdout argument to unzck
- Use meson native versioning rather than manual header and fix
  pkgconfig output

* Tue Jun 12 2018 Jonathan Dieter <jdieter@gmail.com> - 0.7.2-1
- Rename zck_get_dl_range to zck_get_missing_range because it
  was too similar to the unrelated zck_dl_get_range function

* Mon Jun 11 2018 Jonathan Dieter <jdieter@gmail.com> - 0.7.1-1
- New functions in the library

* Fri Jun 08 2018 Jonathan Dieter <jdieter@gmail.com> - 0.7.0-1
- Massive API rework in preparation for ABI stability guarantee

* Wed Jun 06 2018 Jonathan Dieter <jdieter@gmail.com> - 0.6.2-1
- Header and API cleanup
- Fix warnings

* Tue Jun 05 2018 Jonathan Dieter <jdieter@gmail.com> - 0.6.0-1
- Massive rework of zckdl utility
- Main library no longer depends on curl, only zckdl utility
- Rework API
- Support for servers that have different maximum ranges in a request

* Thu May 10 2018 Jonathan Dieter <jdieter@gmail.com> - 0.5.2-1
- Add new zck_get_range() function
- Add tests
- Range functions are no longer prefixed with "Range: bytes="

* Wed May 09 2018 Jonathan Dieter <jdieter@gmail.com> - 0.5.0-1
- Command line utilities now provide help and usage examples and take
  proper flags
- Reading a zchunk header no longer automatically reads the dictionary

* Sun Apr 29 2018 Jonathan Dieter <jdieter@gmail.com> - 0.4.0-1
- Next release with incompatible file format changes
- File format has been reworked to allow checking of the header checksum
  without reading full header into memory at once
- Terminology changes for the header

* Fri Apr 20 2018 Jonathan Dieter <jdieter@gmail.com> - 0.3.0-1
- Next release with incompatible file format changes
- File format now supports streams and signatures

* Tue Apr 17 2018 Jonathan Dieter <jdieter@gmail.com> - 0.2.2-1
- First release
- Fix build on EL7
